-- The sound effects provided are just sounds I found for free online and they are in no way mine, the same goes with any graphics included.

_, class = UnitClass("player")
if class == "MONK" then

local ADDON_NAME, namespace = ...
local L = namespace.L

local fatalitydelay, fatalitynorepeat = 0, true

function MHCopy()
for idx = 1, #MonkHelper_Profiles do
MonkHelper_Profiles[idx].options = MonkHelper_Profiles[1].options
end
end

MHAuraEvents = {
["SPELL_AURA_APPLIED"] = true,
["SPELL_AURA_REMOVED"] = true,
["SPELL_AURA_APPLIED_DOSE"] = true,
["SPELL_AURA_REMOVED_DOSE"] = true,
["SPELL_AURA_REFRESH"] = true,
}

MHDamageEvents = {
["SPELL_DAMAGE"] = true,
["SWING_DAMAGE"] = true,
["RANGE_DAMAGE"] = true,
["SPELL_PERIODIC_DAMAGE"] = true,
["ENVIRONMENTAL_DAMAGE"] = true,
}

MHHealEvents = {
["SPELL_HEAL"] = true, 
["SPELL_PERIODIC_HEAL"] = true,
}


local loaded = false
MHSpec = ""

function MonkHelper_MHTimerOnUpdate(self, elapsed)
MonkHelper_NotificationsOnUpdate(elapsed)
MonkHelper_ParalysisOnUpdate(elapsed)
MonkHelper_UpdateTimers(elapsed)
MonkHelper_ResourceBarOnUpdate(elapsed)

if fatalitydelay > 0 then
fatalitydelay = fatalitydelay - elapsed
if fatalitydelay <= 1.8 and fatalitynorepeat == false then
PlaySoundFile("Interface\\AddOns\\MonkHelper\\Sounds\\touchofdeathbg.mp3", "MASTER")
fatalitynorepeat = true
elseif fatalitydelay <= 0 then
fatalitydelay = 0
PlaySoundFile("Interface\\AddOns\\MonkHelper\\Sounds\\touchofdeath.mp3", "MASTER")
end
end

if MHtimerbypass > 0 then
MHtimerbypass = MHtimerbypass - elapsed
MHParalysisMonitorBarText:SetText(string.sub(MHtimerbypass, 1, 4))
MHParalysisMonitorBar:SetValue(MHtimerbypass)
if MHtimerbypass <= 0 then
MonkHelper_LockFrames()
MHtimerbypass = 0
MonkHelper_CheckCooldowns()
MHParalysisMonitor:Hide()
MHParalysisMonitorBar:SetValue(0)
MHParalysisMonitorBarText:SetText(0)
MonkHelper_HideFrames()
MonkHelper_UpdateUI()
end
end

end


MonkHelperEventFrame = CreateFrame("Frame", "MonkHelperEventFrame", UIParent)
MonkHelperEventFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
MonkHelperEventFrame:RegisterEvent("ADDON_LOADED")
MonkHelperEventFrame:RegisterEvent("PLAYER_ALIVE")
MonkHelperEventFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
MonkHelperEventFrame:RegisterEvent("PLAYER_REGEN_DISABLED")
MonkHelperEventFrame:RegisterEvent("PLAYER_REGEN_ENABLED")
MonkHelperEventFrame:RegisterEvent("PLAYER_SPECIALIZATION_CHANGED")
MonkHelperEventFrame:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")




function MonkHelper_Round(number, decimals)
return tonumber((("%%.%df"):format(decimals)):format(number))
end


function MonkHelper_OnEvent(self, event, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12, arg13, arg14, arg15, arg16)

if event == "PLAYER_REGEN_ENABLED" then
if loaded == true and MHtimerbypass == 0 then
MonkHelper_UnlockFrames()
if MonkHelper_Profiles[MonkHelper_ActiveProfile].options.hideframes == true and MHtimerbypass == 0 and UnitAffectingCombat("player") == false then
MonkHelper_UpdateUI(true)
end
end
elseif event == "PLAYER_REGEN_DISABLED" then
if loaded == true and MHtimerbypass == 0 then
MonkHelper_UpdateUI(false)
MonkHelper_LockFrames()
end
end

if event == "ADDON_LOADED" and arg1 == "MonkHelper" then
MonkHelper_Check(true)
MonkHelper_CreateMiniMapButton()
MonkHelper_CreateParalysisMonitorUI()
MonkHelper_CreateTimersUI()
MonkHelper_CreateResourceBarUI()
MonkHelper_CreateTrackersUI()
MonkHelper_CreateNotificationsUI()

MonkHelper_CreateCastingBarFrameMover()
MonkHelper_CreateOptionsMenu()
MonkHelper_CreateParalysisMonitorOptionsMenu()
MonkHelper_CreateTimersOptionsMenu()
MonkHelper_CreateResourceBarOptionsMenu()
MonkHelper_CreateTrackersOptionsMenu()
MonkHelper_CreateNotificationsOptionsMenu()

MonkHelper_FinishOptionsMenu()
MHTimersScroll:SetMinMaxValues(0, 3100)
MonkHelper_UpdateProfile()
_G["MHProfileFrameContentButton"..MonkHelper_ActiveProfile].clicked = true
_G["MHProfileFrameContentButton"..MonkHelper_ActiveProfile.."Highlight"]:Show()
_G["MHProfileFrameContentButton"..MonkHelper_ActiveProfile.."Highlight"]:SetTexture(1, 1, 0, 0.6)
_G["MHProfileFrameContentButton"..MonkHelper_ActiveProfile.."Text"]:SetTextColor(1, 1, 1)
MonkHelper_Cancel() -- applies scaling & saved text into input boxes
MonkHelper_TimerHandler()
loaded = true

print("|cff00ff96"..L["SLASH"].."|r")
end
if event == "PLAYER_ENTERING_WORLD" then
MonkHelper_OnEvent(nil, "PLAYER_SPECIALIZATION_CHANGED")
MonkHelper_PlaceFrames()
if MonkHelper_Profiles[MonkHelper_ActiveProfile].options.hideframes == true and MHtimerbypass == 0 and UnitAffectingCombat("player") == false then
MonkHelper_UpdateUI(true)
else
MonkHelper_UpdateUI()
end

end

if event == "PLAYER_SPECIALIZATION_CHANGED" or event == "ACTIVE_TALENT_GROUP_CHANGED" then

if GetSpecialization() == 1 then
MHSpec = "Brewmaster"
elseif GetSpecialization() == 2 then
MHSpec = "Mistweaver"
elseif GetSpecialization() == 3 then
MHSpec = "Windwalker"
end
MonkHelper_UpdateUI()
MonkHelper_UpdateResourceBar()
MonkHelper_UpdateHealthBar()
MonkHelper_CheckCooldowns()

end

if event == "COMBAT_LOG_EVENT_UNFILTERED" then

if (arg2 == "SPELL_AURA_APPLIED" or arg2 == "SPELL_AURA_REFRESH" or arg2 == "SPELL_AURA_APPLIED_DOSE") and arg8 == UnitGUID("player") then
if arg12 == MHSpellID["MHVitalMistsTimer"] and MonkHelper_Profiles[MonkHelper_ActiveProfile].options.sound.vitalmists == true then
PlaySoundFile("Interface\\AddOns\\MonkHelper\\Sounds\\vitalmists.mp3", "SFX")
elseif arg12 == MHSpellID["MHTigerPalmTimer"] and MonkHelper_Profiles[MonkHelper_ActiveProfile].options.sound.cbtigerpalm == true then
PlaySoundFile("Interface\\AddOns\\MonkHelper\\Sounds\\tigerpalm.mp3", "SFX")
elseif arg12 == MHSpellID["MHBlackoutKickTimer"] and MonkHelper_Profiles[MonkHelper_ActiveProfile].options.sound.cbblackoutkick == true then
PlaySoundFile("Interface\\AddOns\\MonkHelper\\Sounds\\blackoutkick.mp3", "SFX")
end
end

if arg2 == "SPELL_CAST_SUCCESS" and arg4 == UnitGUID("player") then 
if arg12 == MHSpellID["MHTouchOfDeathTimer"] and MonkHelper_Profiles[MonkHelper_ActiveProfile].options.sound.touchofdeath == true then 
fatalitynorepeat = false
fatalitydelay = 2.5
else
--if UnitIsPlayer(arg9) and arg8 ~= UnitGUID("player") and MageCandy_Profiles[MageCandy_ActiveProfile].options.show.slowfallmessage == 1 then
--SendChatMessage(MageCandy_Profiles[MageCandy_ActiveProfile].options.input.slowfallmessage, "WHISPER", nil, arg9) 
--end

end

end

end

end




function MonkHelper_ShortNumber(num)
if num == 0 then
return num
elseif num > 0 and num < 0.1 then
if string.sub(num, 5, 5) ~= "" and string.sub(num, 5, 5) ~= nil then
return string.sub(num,4, 4).."."..string.sub(num, 5, 5)
else
return string.sub(num,4, 4)
end
elseif num >= 0 and num < 1 then
if string.sub(num, 5, 5) ~= nil and string.sub(num, 5, 5) ~= "" then
return string.sub(num, 3, 4).."."..string.sub(num, 5, 5)
elseif num == 0.1 or num == 0.2 or num == 0.3 or num == 0.4 or num == 0.5 or num == 0.6 or num == 0.7
or num == 0.8 or num == 0.9 then
num = string.sub(num, 3, 3).."0"
return num
else
return string.sub(num, 3, 4)
end
elseif num == 1 then
return 100
elseif num > 999 then
num = string.sub(num, 1, string.len(num) - 3)..","..string.sub(num, string.len(num) - 2, string.len(num))
return num
elseif num == nil then
return 0
else 
return num
end
end

function MonkHelper_CondenseNumber(num)
local length = string.len(num)
if num < 1000 then
return num
elseif num >= 1000 and num < 1000000 then
num = string.sub(num, 1, length - 3).."k"
return num
elseif num >= 1000000 then
num = string.sub(num, 1, length - 6).."m"
return num
end
end


function MonkHelper_ScanUnit(unit, bufftype, caster, id)
local name, rank, icon, count, debufftype, duration, expirationtime, unitcaster, isstealable, shouldconsolidate, spellid
if bufftype == "debuff" then
for idx = 1, 40 do
name, rank, icon, count, debufftype, duration, expirationtime, unitcaster, isstealable, shouldconsolidate, spellid = UnitDebuff(unit, idx)
if name == nil then break end
if spellid == id and unitcaster == caster then
if duration == nil then duration = 0 end
if expiration == nil then expiration = 0 end
return duration, expirationtime
end
end
elseif bufftype == "buff" then
for idx = 1, 40 do
name, rank, icon, count, debufftype, duration, expirationtime, unitcaster, isstealable, shouldconsolidate, spellid = UnitBuff(unit, idx)
if name == nil then break end
if spellid == id then
if duration == nil then duration = 0 end
if expiration == nil then expiration = 0 end
return duration, expirationtime
end
end
else
return 0, 0
end
return 0, 0
end

-- And finally, set the event handler script and the main timer frame

CreateFrame("Frame", "MHTimer", UIParent)
MHTimer:SetScript("OnUpdate", MonkHelper_MHTimerOnUpdate)
MHTimer:SetWidth(30)
MHTimer:SetHeight(30)
MHTimer:SetPoint("CENTER", UIParent, "CENTER")
MHTimer:CreateFontString("$parentText", "OVERLAY", "GameFontNormal")

hooksecurefunc("PlayerFrame_DetachCastBar", MonkHelper_PlaceCastingBar)
MonkHelperEventFrame:SetScript("OnEvent", MonkHelper_OnEvent)
end